// Generated by rstantools.  Do not edit by hand.

/*
    MIRES is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    MIRES is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with MIRES.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef MODELS_HPP
#define MODELS_HPP
#define STAN__SERVICES__COMMAND_HPP
#ifndef USE_STANC3
#define USE_STANC3
#endif
#include <rstan/rstaninc.hpp>
// Code generated by stanc v2.32.2
#include <stan/model/model_header.hpp>
namespace model_dpExp_namespace {
using stan::model::model_base_crtp;
using namespace stan::math;
stan::math::profile_map profiles__;
static constexpr std::array<const char*, 35> locations_array__ =
  {" (found before start of program)",
  " (in 'dpExp', line 24, column 2 to column 24)",
  " (in 'dpExp', line 25, column 2 to column 51)",
  " (in 'dpExp', line 27, column 2 to column 26)",
  " (in 'dpExp', line 30, column 2 to column 81)",
  " (in 'dpExp', line 35, column 9 to column 10)",
  " (in 'dpExp', line 35, column 2 to column 29)",
  " (in 'dpExp', line 37, column 2 to column 22)",
  " (in 'dpExp', line 38, column 2 to column 22)",
  " (in 'dpExp', line 39, column 2 to column 32)",
  " (in 'dpExp', line 47, column 11 to column 12)",
  " (in 'dpExp', line 47, column 4 to column 28)",
  " (in 'dpExp', line 49, column 6 to column 50)",
  " (in 'dpExp', line 48, column 18 to line 50, column 5)",
  " (in 'dpExp', line 48, column 4 to line 50, column 5)",
  " (in 'dpExp', line 51, column 4 to column 32)",
  " (in 'dpExp', line 46, column 16 to line 52, column 3)",
  " (in 'dpExp', line 46, column 2 to line 52, column 3)",
  " (in 'dpExp', line 15, column 2 to column 8)",
  " (in 'dpExp', line 16, column 2 to column 8)",
  " (in 'dpExp', line 17, column 9 to column 10)",
  " (in 'dpExp', line 17, column 2 to column 14)",
  " (in 'dpExp', line 25, column 31 to column 36)",
  " (in 'dpExp', line 27, column 18 to column 19)",
  " (in 'dpExp', line 30, column 31 to column 32)",
  " (in 'dpExp', line 3, column 4 to column 43)",
  " (in 'dpExp', line 4, column 11 to column 12)",
  " (in 'dpExp', line 4, column 4 to column 17)",
  " (in 'dpExp', line 5, column 4 to column 28)",
  " (in 'dpExp', line 7, column 6 to column 66)",
  " (in 'dpExp', line 6, column 24 to line 8, column 5)",
  " (in 'dpExp', line 6, column 4 to line 8, column 5)",
  " (in 'dpExp', line 10, column 4 to column 46)",
  " (in 'dpExp', line 11, column 4 to column 15)",
  " (in 'dpExp', line 2, column 47 to line 12, column 3)"};
template <typename T0__,
          stan::require_all_t<stan::is_col_vector<T0__>,
                              stan::is_vt_not_complex<T0__>>* = nullptr>
Eigen::Matrix<stan::promote_args_t<stan::base_type_t<T0__>>,-1,1>
break_that_stick(const T0__& stick_slices_arg__, std::ostream* pstream__);
template <typename T0__,
          stan::require_all_t<stan::is_col_vector<T0__>,
                              stan::is_vt_not_complex<T0__>>*>
Eigen::Matrix<stan::promote_args_t<stan::base_type_t<T0__>>,-1,1>
break_that_stick(const T0__& stick_slices_arg__, std::ostream* pstream__) {
  using local_scalar_t__ = stan::promote_args_t<stan::base_type_t<T0__>>;
  int current_statement__ = 0;
  const auto& stick_slices = stan::math::to_ref(stick_slices_arg__);
  static constexpr bool propto__ = true;
  // suppress unused var warning
  (void) propto__;
  local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
  // suppress unused var warning
  (void) DUMMY_VAR__;
  try {
    int K = std::numeric_limits<int>::min();
    current_statement__ = 25;
    K = (stan::math::num_elements(stick_slices) + 1);
    current_statement__ = 26;
    stan::math::validate_non_negative_index("pi", "K", K);
    Eigen::Matrix<local_scalar_t__,-1,1> pi =
      Eigen::Matrix<local_scalar_t__,-1,1>::Constant(K, DUMMY_VAR__);
    current_statement__ = 28;
    stan::model::assign(pi,
      stan::model::rvalue(stick_slices, "stick_slices",
        stan::model::index_uni(1)), "assigning variable pi",
      stan::model::index_uni(1));
    current_statement__ = 31;
    for (int k = 2; k <= (K - 1); ++k) {
      current_statement__ = 29;
      stan::model::assign(pi,
        (stan::model::rvalue(stick_slices, "stick_slices",
           stan::model::index_uni(k)) *
        stan::math::prod(
          stan::math::subtract(1,
            stan::model::rvalue(stick_slices, "stick_slices",
              stan::model::index_min_max(1, (k - 1)))))),
        "assigning variable pi", stan::model::index_uni(k));
    }
    current_statement__ = 32;
    stan::model::assign(pi,
      stan::math::prod(
        stan::math::subtract(1,
          stan::model::rvalue(stick_slices, "stick_slices",
            stan::model::index_min_max(1, (K - 1))))),
      "assigning variable pi", stan::model::index_uni(K));
    current_statement__ = 33;
    return pi;
  } catch (const std::exception& e) {
    stan::lang::rethrow_located(e, locations_array__[current_statement__]);
  }
}
#include <stan_meta_header.hpp>
class model_dpExp final : public model_base_crtp<model_dpExp> {
private:
  int N;
  int K;
  Eigen::Matrix<double,-1,1> y_data__;
  int stick_slices_1dim__;
  Eigen::Map<Eigen::Matrix<double,-1,1>> y{nullptr, 0};
public:
  ~model_dpExp() {}
  model_dpExp(stan::io::var_context& context__, unsigned int
              random_seed__ = 0, std::ostream* pstream__ = nullptr)
      : model_base_crtp(0) {
    int current_statement__ = 0;
    using local_scalar_t__ = double;
    boost::ecuyer1988 base_rng__ =
      stan::services::util::create_rng(random_seed__, 0);
    // suppress unused var warning
    (void) base_rng__;
    static constexpr const char* function__ =
      "model_dpExp_namespace::model_dpExp";
    // suppress unused var warning
    (void) function__;
    local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
    // suppress unused var warning
    (void) DUMMY_VAR__;
    try {
      int pos__ = std::numeric_limits<int>::min();
      pos__ = 1;
      current_statement__ = 18;
      context__.validate_dims("data initialization", "N", "int",
        std::vector<size_t>{});
      N = std::numeric_limits<int>::min();
      current_statement__ = 18;
      N = context__.vals_i("N")[(1 - 1)];
      current_statement__ = 19;
      context__.validate_dims("data initialization", "K", "int",
        std::vector<size_t>{});
      K = std::numeric_limits<int>::min();
      current_statement__ = 19;
      K = context__.vals_i("K")[(1 - 1)];
      current_statement__ = 20;
      stan::math::validate_non_negative_index("y", "N", N);
      current_statement__ = 21;
      context__.validate_dims("data initialization", "y", "double",
        std::vector<size_t>{static_cast<size_t>(N)});
      y_data__ = Eigen::Matrix<double,-1,1>::Constant(N,
                   std::numeric_limits<double>::quiet_NaN());
      new (&y) Eigen::Map<Eigen::Matrix<double,-1,1>>(y_data__.data(), N);
      {
        std::vector<local_scalar_t__> y_flat__;
        current_statement__ = 21;
        y_flat__ = context__.vals_r("y");
        current_statement__ = 21;
        pos__ = 1;
        current_statement__ = 21;
        for (int sym1__ = 1; sym1__ <= N; ++sym1__) {
          current_statement__ = 21;
          stan::model::assign(y, y_flat__[(pos__ - 1)],
            "assigning variable y", stan::model::index_uni(sym1__));
          current_statement__ = 21;
          pos__ = (pos__ + 1);
        }
      }
      current_statement__ = 22;
      stick_slices_1dim__ = std::numeric_limits<int>::min();
      current_statement__ = 22;
      stick_slices_1dim__ = (K - 1);
      current_statement__ = 22;
      stan::math::validate_non_negative_index("stick_slices", "K - 1",
        stick_slices_1dim__);
      current_statement__ = 23;
      stan::math::validate_non_negative_index("rate", "K", K);
      current_statement__ = 24;
      stan::math::validate_non_negative_index("pi", "K", K);
    } catch (const std::exception& e) {
      stan::lang::rethrow_located(e, locations_array__[current_statement__]);
    }
    num_params_r__ = 1 + stick_slices_1dim__ + K;
  }
  inline std::string model_name() const final {
    return "model_dpExp";
  }
  inline std::vector<std::string> model_compile_info() const noexcept {
    return std::vector<std::string>{"stanc_version = stanc3 v2.32.2",
             "stancflags = --allow-undefined"};
  }
  template <bool propto__, bool jacobian__, typename VecR, typename VecI,
            stan::require_vector_like_t<VecR>* = nullptr,
            stan::require_vector_like_vt<std::is_integral, VecI>* = nullptr>
  inline stan::scalar_type_t<VecR>
  log_prob_impl(VecR& params_r__, VecI& params_i__, std::ostream*
                pstream__ = nullptr) const {
    using T__ = stan::scalar_type_t<VecR>;
    using local_scalar_t__ = T__;
    T__ lp__(0.0);
    stan::math::accumulator<T__> lp_accum__;
    stan::io::deserializer<local_scalar_t__> in__(params_r__, params_i__);
    int current_statement__ = 0;
    local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
    // suppress unused var warning
    (void) DUMMY_VAR__;
    static constexpr const char* function__ =
      "model_dpExp_namespace::log_prob";
    // suppress unused var warning
    (void) function__;
    try {
      local_scalar_t__ alpha = DUMMY_VAR__;
      current_statement__ = 1;
      alpha = in__.template read_constrain_lb<local_scalar_t__,
                jacobian__>(0, lp__);
      Eigen::Matrix<local_scalar_t__,-1,1> stick_slices =
        Eigen::Matrix<local_scalar_t__,-1,1>::Constant(stick_slices_1dim__,
          DUMMY_VAR__);
      current_statement__ = 2;
      stick_slices = in__.template read_constrain_lub<
                       Eigen::Matrix<local_scalar_t__,-1,1>, jacobian__>(0,
                       1, lp__, stick_slices_1dim__);
      Eigen::Matrix<local_scalar_t__,-1,1> rate =
        Eigen::Matrix<local_scalar_t__,-1,1>::Constant(K, DUMMY_VAR__);
      current_statement__ = 3;
      rate = in__.template read_constrain_lb<
               Eigen::Matrix<local_scalar_t__,-1,1>, jacobian__>(0, lp__, K);
      Eigen::Matrix<local_scalar_t__,-1,1> pi =
        Eigen::Matrix<local_scalar_t__,-1,1>::Constant(K, DUMMY_VAR__);
      current_statement__ = 4;
      stan::model::assign(pi,
        stan::math::sort_desc(break_that_stick(stick_slices, pstream__)),
        "assigning variable pi");
      current_statement__ = 4;
      stan::math::check_greater_or_equal(function__, "pi", pi, 0);
      current_statement__ = 4;
      stan::math::check_less_or_equal(function__, "pi", pi, 1);
      {
        current_statement__ = 5;
        stan::math::validate_non_negative_index("log_pi", "K", K);
        Eigen::Matrix<local_scalar_t__,-1,1> log_pi =
          Eigen::Matrix<local_scalar_t__,-1,1>::Constant(K, DUMMY_VAR__);
        current_statement__ = 6;
        stan::model::assign(log_pi, stan::math::log(pi),
          "assigning variable log_pi");
        current_statement__ = 7;
        lp_accum__.add(stan::math::normal_lpdf<propto__>(rate, 0, 3));
        current_statement__ = 8;
        lp_accum__.add(stan::math::gamma_lpdf<propto__>(alpha, 2, 2));
        current_statement__ = 9;
        lp_accum__.add(stan::math::beta_lpdf<propto__>(stick_slices, 1, alpha));
        current_statement__ = 17;
        for (int n = 1; n <= N; ++n) {
          current_statement__ = 10;
          stan::math::validate_non_negative_index("lp_y", "K", K);
          Eigen::Matrix<local_scalar_t__,-1,1> lp_y =
            Eigen::Matrix<local_scalar_t__,-1,1>::Constant(K, DUMMY_VAR__);
          current_statement__ = 11;
          stan::model::assign(lp_y, log_pi, "assigning variable lp_y");
          current_statement__ = 14;
          for (int k = 1; k <= K; ++k) {
            current_statement__ = 12;
            stan::model::assign(lp_y,
              (stan::model::rvalue(lp_y, "lp_y", stan::model::index_uni(k)) +
              stan::math::exponential_lpdf<false>(
                stan::model::rvalue(y, "y", stan::model::index_uni(n)),
                stan::model::rvalue(rate, "rate", stan::model::index_uni(k)))),
              "assigning variable lp_y", stan::model::index_uni(k));
          }
          current_statement__ = 15;
          lp_accum__.add(stan::math::log_sum_exp(lp_y));
        }
      }
    } catch (const std::exception& e) {
      stan::lang::rethrow_located(e, locations_array__[current_statement__]);
    }
    lp_accum__.add(lp__);
    return lp_accum__.sum();
  }
  template <typename RNG, typename VecR, typename VecI, typename VecVar,
            stan::require_vector_like_vt<std::is_floating_point,
            VecR>* = nullptr, stan::require_vector_like_vt<std::is_integral,
            VecI>* = nullptr, stan::require_vector_vt<std::is_floating_point,
            VecVar>* = nullptr>
  inline void
  write_array_impl(RNG& base_rng__, VecR& params_r__, VecI& params_i__,
                   VecVar& vars__, const bool
                   emit_transformed_parameters__ = true, const bool
                   emit_generated_quantities__ = true, std::ostream*
                   pstream__ = nullptr) const {
    using local_scalar_t__ = double;
    stan::io::deserializer<local_scalar_t__> in__(params_r__, params_i__);
    stan::io::serializer<local_scalar_t__> out__(vars__);
    static constexpr bool propto__ = true;
    // suppress unused var warning
    (void) propto__;
    double lp__ = 0.0;
    // suppress unused var warning
    (void) lp__;
    int current_statement__ = 0;
    stan::math::accumulator<double> lp_accum__;
    local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
    // suppress unused var warning
    (void) DUMMY_VAR__;
    constexpr bool jacobian__ = false;
    static constexpr const char* function__ =
      "model_dpExp_namespace::write_array";
    // suppress unused var warning
    (void) function__;
    try {
      double alpha = std::numeric_limits<double>::quiet_NaN();
      current_statement__ = 1;
      alpha = in__.template read_constrain_lb<local_scalar_t__,
                jacobian__>(0, lp__);
      Eigen::Matrix<double,-1,1> stick_slices =
        Eigen::Matrix<double,-1,1>::Constant(stick_slices_1dim__,
          std::numeric_limits<double>::quiet_NaN());
      current_statement__ = 2;
      stick_slices = in__.template read_constrain_lub<
                       Eigen::Matrix<local_scalar_t__,-1,1>, jacobian__>(0,
                       1, lp__, stick_slices_1dim__);
      Eigen::Matrix<double,-1,1> rate =
        Eigen::Matrix<double,-1,1>::Constant(K,
          std::numeric_limits<double>::quiet_NaN());
      current_statement__ = 3;
      rate = in__.template read_constrain_lb<
               Eigen::Matrix<local_scalar_t__,-1,1>, jacobian__>(0, lp__, K);
      Eigen::Matrix<double,-1,1> pi =
        Eigen::Matrix<double,-1,1>::Constant(K,
          std::numeric_limits<double>::quiet_NaN());
      out__.write(alpha);
      out__.write(stick_slices);
      out__.write(rate);
      if (stan::math::logical_negation(
            (stan::math::primitive_value(emit_transformed_parameters__) ||
            stan::math::primitive_value(emit_generated_quantities__)))) {
        return ;
      }
      current_statement__ = 4;
      stan::model::assign(pi,
        stan::math::sort_desc(break_that_stick(stick_slices, pstream__)),
        "assigning variable pi");
      current_statement__ = 4;
      stan::math::check_greater_or_equal(function__, "pi", pi, 0);
      current_statement__ = 4;
      stan::math::check_less_or_equal(function__, "pi", pi, 1);
      if (emit_transformed_parameters__) {
        out__.write(pi);
      }
      if (stan::math::logical_negation(emit_generated_quantities__)) {
        return ;
      }
    } catch (const std::exception& e) {
      stan::lang::rethrow_located(e, locations_array__[current_statement__]);
    }
  }
  template <typename VecVar, typename VecI,
            stan::require_vector_t<VecVar>* = nullptr,
            stan::require_vector_like_vt<std::is_integral, VecI>* = nullptr>
  inline void
  unconstrain_array_impl(const VecVar& params_r__, const VecI& params_i__,
                         VecVar& vars__, std::ostream* pstream__ = nullptr) const {
    using local_scalar_t__ = double;
    stan::io::deserializer<local_scalar_t__> in__(params_r__, params_i__);
    stan::io::serializer<local_scalar_t__> out__(vars__);
    int current_statement__ = 0;
    local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
    // suppress unused var warning
    (void) DUMMY_VAR__;
    try {
      int pos__ = std::numeric_limits<int>::min();
      pos__ = 1;
      local_scalar_t__ alpha = DUMMY_VAR__;
      current_statement__ = 1;
      alpha = in__.read<local_scalar_t__>();
      out__.write_free_lb(0, alpha);
      Eigen::Matrix<local_scalar_t__,-1,1> stick_slices =
        Eigen::Matrix<local_scalar_t__,-1,1>::Constant(stick_slices_1dim__,
          DUMMY_VAR__);
      current_statement__ = 2;
      stan::model::assign(stick_slices,
        in__.read<Eigen::Matrix<local_scalar_t__,-1,1>>(stick_slices_1dim__),
        "assigning variable stick_slices");
      out__.write_free_lub(0, 1, stick_slices);
      Eigen::Matrix<local_scalar_t__,-1,1> rate =
        Eigen::Matrix<local_scalar_t__,-1,1>::Constant(K, DUMMY_VAR__);
      current_statement__ = 3;
      stan::model::assign(rate,
        in__.read<Eigen::Matrix<local_scalar_t__,-1,1>>(K),
        "assigning variable rate");
      out__.write_free_lb(0, rate);
    } catch (const std::exception& e) {
      stan::lang::rethrow_located(e, locations_array__[current_statement__]);
    }
  }
  template <typename VecVar, stan::require_vector_t<VecVar>* = nullptr>
  inline void
  transform_inits_impl(const stan::io::var_context& context__, VecVar&
                       vars__, std::ostream* pstream__ = nullptr) const {
    using local_scalar_t__ = double;
    stan::io::serializer<local_scalar_t__> out__(vars__);
    int current_statement__ = 0;
    local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
    // suppress unused var warning
    (void) DUMMY_VAR__;
    try {
      current_statement__ = 1;
      context__.validate_dims("parameter initialization", "alpha", "double",
        std::vector<size_t>{});
      current_statement__ = 2;
      context__.validate_dims("parameter initialization", "stick_slices",
        "double",
        std::vector<size_t>{static_cast<size_t>(stick_slices_1dim__)});
      current_statement__ = 3;
      context__.validate_dims("parameter initialization", "rate", "double",
        std::vector<size_t>{static_cast<size_t>(K)});
      int pos__ = std::numeric_limits<int>::min();
      pos__ = 1;
      local_scalar_t__ alpha = DUMMY_VAR__;
      current_statement__ = 1;
      alpha = context__.vals_r("alpha")[(1 - 1)];
      out__.write_free_lb(0, alpha);
      Eigen::Matrix<local_scalar_t__,-1,1> stick_slices =
        Eigen::Matrix<local_scalar_t__,-1,1>::Constant(stick_slices_1dim__,
          DUMMY_VAR__);
      {
        std::vector<local_scalar_t__> stick_slices_flat__;
        current_statement__ = 2;
        stick_slices_flat__ = context__.vals_r("stick_slices");
        current_statement__ = 2;
        pos__ = 1;
        current_statement__ = 2;
        for (int sym1__ = 1; sym1__ <= stick_slices_1dim__; ++sym1__) {
          current_statement__ = 2;
          stan::model::assign(stick_slices, stick_slices_flat__[(pos__ - 1)],
            "assigning variable stick_slices", stan::model::index_uni(sym1__));
          current_statement__ = 2;
          pos__ = (pos__ + 1);
        }
      }
      out__.write_free_lub(0, 1, stick_slices);
      Eigen::Matrix<local_scalar_t__,-1,1> rate =
        Eigen::Matrix<local_scalar_t__,-1,1>::Constant(K, DUMMY_VAR__);
      {
        std::vector<local_scalar_t__> rate_flat__;
        current_statement__ = 3;
        rate_flat__ = context__.vals_r("rate");
        current_statement__ = 3;
        pos__ = 1;
        current_statement__ = 3;
        for (int sym1__ = 1; sym1__ <= K; ++sym1__) {
          current_statement__ = 3;
          stan::model::assign(rate, rate_flat__[(pos__ - 1)],
            "assigning variable rate", stan::model::index_uni(sym1__));
          current_statement__ = 3;
          pos__ = (pos__ + 1);
        }
      }
      out__.write_free_lb(0, rate);
    } catch (const std::exception& e) {
      stan::lang::rethrow_located(e, locations_array__[current_statement__]);
    }
  }
  inline void
  get_param_names(std::vector<std::string>& names__, const bool
                  emit_transformed_parameters__ = true, const bool
                  emit_generated_quantities__ = true) const {
    names__ = std::vector<std::string>{"alpha", "stick_slices", "rate"};
    if (emit_transformed_parameters__) {
      std::vector<std::string> temp{"pi"};
      names__.reserve(names__.size() + temp.size());
      names__.insert(names__.end(), temp.begin(), temp.end());
    }
    if (emit_generated_quantities__) {}
  }
  inline void
  get_dims(std::vector<std::vector<size_t>>& dimss__, const bool
           emit_transformed_parameters__ = true, const bool
           emit_generated_quantities__ = true) const {
    dimss__ = std::vector<std::vector<size_t>>{std::vector<size_t>{},
                std::vector<size_t>{static_cast<size_t>(stick_slices_1dim__)},
                std::vector<size_t>{static_cast<size_t>(K)}};
    if (emit_transformed_parameters__) {
      std::vector<std::vector<size_t>>
        temp{std::vector<size_t>{static_cast<size_t>(K)}};
      dimss__.reserve(dimss__.size() + temp.size());
      dimss__.insert(dimss__.end(), temp.begin(), temp.end());
    }
    if (emit_generated_quantities__) {}
  }
  inline void
  constrained_param_names(std::vector<std::string>& param_names__, bool
                          emit_transformed_parameters__ = true, bool
                          emit_generated_quantities__ = true) const final {
    param_names__.emplace_back(std::string() + "alpha");
    for (int sym1__ = 1; sym1__ <= stick_slices_1dim__; ++sym1__) {
      param_names__.emplace_back(std::string() + "stick_slices" + '.' +
        std::to_string(sym1__));
    }
    for (int sym1__ = 1; sym1__ <= K; ++sym1__) {
      param_names__.emplace_back(std::string() + "rate" + '.' +
        std::to_string(sym1__));
    }
    if (emit_transformed_parameters__) {
      for (int sym1__ = 1; sym1__ <= K; ++sym1__) {
        param_names__.emplace_back(std::string() + "pi" + '.' +
          std::to_string(sym1__));
      }
    }
    if (emit_generated_quantities__) {}
  }
  inline void
  unconstrained_param_names(std::vector<std::string>& param_names__, bool
                            emit_transformed_parameters__ = true, bool
                            emit_generated_quantities__ = true) const final {
    param_names__.emplace_back(std::string() + "alpha");
    for (int sym1__ = 1; sym1__ <= stick_slices_1dim__; ++sym1__) {
      param_names__.emplace_back(std::string() + "stick_slices" + '.' +
        std::to_string(sym1__));
    }
    for (int sym1__ = 1; sym1__ <= K; ++sym1__) {
      param_names__.emplace_back(std::string() + "rate" + '.' +
        std::to_string(sym1__));
    }
    if (emit_transformed_parameters__) {
      for (int sym1__ = 1; sym1__ <= K; ++sym1__) {
        param_names__.emplace_back(std::string() + "pi" + '.' +
          std::to_string(sym1__));
      }
    }
    if (emit_generated_quantities__) {}
  }
  inline std::string get_constrained_sizedtypes() const {
    return std::string("[{\"name\":\"alpha\",\"type\":{\"name\":\"real\"},\"block\":\"parameters\"},{\"name\":\"stick_slices\",\"type\":{\"name\":\"vector\",\"length\":" + std::to_string(stick_slices_1dim__) + "},\"block\":\"parameters\"},{\"name\":\"rate\",\"type\":{\"name\":\"vector\",\"length\":" + std::to_string(K) + "},\"block\":\"parameters\"},{\"name\":\"pi\",\"type\":{\"name\":\"vector\",\"length\":" + std::to_string(K) + "},\"block\":\"transformed_parameters\"}]");
  }
  inline std::string get_unconstrained_sizedtypes() const {
    return std::string("[{\"name\":\"alpha\",\"type\":{\"name\":\"real\"},\"block\":\"parameters\"},{\"name\":\"stick_slices\",\"type\":{\"name\":\"vector\",\"length\":" + std::to_string(stick_slices_1dim__) + "},\"block\":\"parameters\"},{\"name\":\"rate\",\"type\":{\"name\":\"vector\",\"length\":" + std::to_string(K) + "},\"block\":\"parameters\"},{\"name\":\"pi\",\"type\":{\"name\":\"vector\",\"length\":" + std::to_string(K) + "},\"block\":\"transformed_parameters\"}]");
  }
  // Begin method overload boilerplate
  template <typename RNG> inline void
  write_array(RNG& base_rng, Eigen::Matrix<double,-1,1>& params_r,
              Eigen::Matrix<double,-1,1>& vars, const bool
              emit_transformed_parameters = true, const bool
              emit_generated_quantities = true, std::ostream*
              pstream = nullptr) const {
    const size_t num_params__ = ((1 + stick_slices_1dim__) + K);
    const size_t num_transformed = emit_transformed_parameters * (K);
    const size_t num_gen_quantities = emit_generated_quantities * (0);
    const size_t num_to_write = num_params__ + num_transformed +
      num_gen_quantities;
    std::vector<int> params_i;
    vars = Eigen::Matrix<double,-1,1>::Constant(num_to_write,
             std::numeric_limits<double>::quiet_NaN());
    write_array_impl(base_rng, params_r, params_i, vars,
      emit_transformed_parameters, emit_generated_quantities, pstream);
  }
  template <typename RNG> inline void
  write_array(RNG& base_rng, std::vector<double>& params_r, std::vector<int>&
              params_i, std::vector<double>& vars, bool
              emit_transformed_parameters = true, bool
              emit_generated_quantities = true, std::ostream*
              pstream = nullptr) const {
    const size_t num_params__ = ((1 + stick_slices_1dim__) + K);
    const size_t num_transformed = emit_transformed_parameters * (K);
    const size_t num_gen_quantities = emit_generated_quantities * (0);
    const size_t num_to_write = num_params__ + num_transformed +
      num_gen_quantities;
    vars = std::vector<double>(num_to_write,
             std::numeric_limits<double>::quiet_NaN());
    write_array_impl(base_rng, params_r, params_i, vars,
      emit_transformed_parameters, emit_generated_quantities, pstream);
  }
  template <bool propto__, bool jacobian__, typename T_> inline T_
  log_prob(Eigen::Matrix<T_,-1,1>& params_r, std::ostream* pstream = nullptr) const {
    Eigen::Matrix<int,-1,1> params_i;
    return log_prob_impl<propto__, jacobian__>(params_r, params_i, pstream);
  }
  template <bool propto__, bool jacobian__, typename T_> inline T_
  log_prob(std::vector<T_>& params_r, std::vector<int>& params_i,
           std::ostream* pstream = nullptr) const {
    return log_prob_impl<propto__, jacobian__>(params_r, params_i, pstream);
  }
  inline void
  transform_inits(const stan::io::var_context& context,
                  Eigen::Matrix<double,-1,1>& params_r, std::ostream*
                  pstream = nullptr) const final {
    std::vector<double> params_r_vec(params_r.size());
    std::vector<int> params_i;
    transform_inits(context, params_i, params_r_vec, pstream);
    params_r = Eigen::Map<Eigen::Matrix<double,-1,1>>(params_r_vec.data(),
                 params_r_vec.size());
  }
  inline void
  transform_inits(const stan::io::var_context& context, std::vector<int>&
                  params_i, std::vector<double>& vars, std::ostream*
                  pstream__ = nullptr) const {
    vars.resize(num_params_r__);
    transform_inits_impl(context, vars, pstream__);
  }
  inline void
  unconstrain_array(const std::vector<double>& params_constrained,
                    std::vector<double>& params_unconstrained, std::ostream*
                    pstream = nullptr) const {
    const std::vector<int> params_i;
    params_unconstrained = std::vector<double>(num_params_r__,
                             std::numeric_limits<double>::quiet_NaN());
    unconstrain_array_impl(params_constrained, params_i,
      params_unconstrained, pstream);
  }
  inline void
  unconstrain_array(const Eigen::Matrix<double,-1,1>& params_constrained,
                    Eigen::Matrix<double,-1,1>& params_unconstrained,
                    std::ostream* pstream = nullptr) const {
    const std::vector<int> params_i;
    params_unconstrained = Eigen::Matrix<double,-1,1>::Constant(num_params_r__,
                             std::numeric_limits<double>::quiet_NaN());
    unconstrain_array_impl(params_constrained, params_i,
      params_unconstrained, pstream);
  }
};
}
using stan_model = model_dpExp_namespace::model_dpExp;
#ifndef USING_R
// Boilerplate
stan::model::model_base&
new_model(stan::io::var_context& data_context, unsigned int seed,
          std::ostream* msg_stream) {
  stan_model* m = new stan_model(data_context, seed, msg_stream);
  return *m;
}
stan::math::profile_map& get_stan_profile_data() {
  return model_dpExp_namespace::profiles__;
}
#endif
#endif
